<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="thinkQrcodeId"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'image'">
              <a-image :src="record.image" :width="50" />
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <ThinkQrcodeEdit v-model:visible="showEdit" :data="current" @done="reload" />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import ThinkQrcodeEdit from './components/thinkQrcodeEdit.vue';
  import { pageThinkQrcode, removeThinkQrcode, removeBatchThinkQrcode } from '@/api/think/thinkQrcode';
  import type { ThinkQrcode, ThinkQrcodeParam } from '@/api/think/thinkQrcode/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<ThinkQrcode[]>([]);
  // 当前编辑数据
  const current = ref<ThinkQrcode | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageThinkQrcode({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: '主键',
      dataIndex: 'id',
      key: 'id',
      align: 'center',
      width: 90,
    },
    {
      title: '二维码本身的值,大小不确定。可能为json，链接，文本 ',
      dataIndex: 'codeValue',
      key: 'codeValue',
      align: 'center',
    },
    {
      title: '关联的用户id，默认用户为uuid 即使为数字 转为字符保存 ',
      dataIndex: 'codeRelUser',
      key: 'codeRelUser',
      align: 'center',
    },
    {
      title: '关联的用户类型 wechat: 微信用户 ,sys:系统用户，other:其他',
      dataIndex: 'userType',
      key: 'userType',
      align: 'center',
    },
    {
      title: '有效开始时间',
      dataIndex: 'codeValidStartTime',
      key: 'codeValidStartTime',
      align: 'center',
    },
    {
      title: '有效结束时间 默认五分钟后过期',
      dataIndex: 'codeValidEndTime',
      key: 'codeValidEndTime',
      align: 'center',
    },
    {
      title: '是否使用 0 未使用 1 已使用',
      dataIndex: 'codeUsStatus',
      key: 'codeUsStatus',
      align: 'center',
    },
    {
      title: '二维码可使用次数,默认一次',
      dataIndex: 'codeUsabaleNumber',
      key: 'codeUsabaleNumber',
      align: 'center',
    },
    {
      title: '二维码已经使用次数，可以超过可使用次数，不想建立一个记录表，用这个字段进行统计',
      dataIndex: 'codeUsNumber',
      key: 'codeUsNumber',
      align: 'center',
    },
    {
      title: '二维码类型 valve:阀门;other:其他 ，后期继续添加 ',
      dataIndex: 'codeType',
      key: 'codeType',
      align: 'center',
    },
    {
      title: '二维码实际转发地址 ： 预留字段 可能该系统不一定用到',
      dataIndex: 'codeForward',
      key: 'codeForward',
      align: 'center',
    },
    {
      title: '创建时间',
      dataIndex: 'crateTime',
      key: 'crateTime',
      align: 'center',
    },
    {
      title: '创建人id',
      dataIndex: 'createUser',
      key: 'createUser',
      align: 'center',
    },
    {
      title: '更新次数',
      dataIndex: 'updateNumber',
      key: 'updateNumber',
      align: 'center',
    },
    {
      title: '最近更新时间，作为系统设计预留字段',
      dataIndex: 'updateTime',
      key: 'updateTime',
      align: 'center',
    },
    {
      title: '最近更新数据id 系统设计使用',
      dataIndex: 'updateUser',
      key: 'updateUser',
      align: 'center',
    },
    {
      title: '数据逻辑删除状态 0:未删除 1 ：已删除； 物理删除不用考虑该字段 作为系统设计预留字段',
      dataIndex: 'deleteStatus',
      key: 'deleteStatus',
      align: 'center',
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: ThinkQrcodeParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: ThinkQrcode) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: ThinkQrcode) => {
    const hide = message.loading('请求中..', 0);
    removeThinkQrcode(row.thinkQrcodeId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchThinkQrcode(selection.value.map((d) => d.thinkQrcodeId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: ThinkQrcode) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'ThinkQrcode'
  };
</script>

<style lang="less" scoped></style>
